#include <PalmOS.h>
#include <PalmTypes.h>
#include <MemoryMgr.h>
#include <StringMgr.h>
class string {
public:
   string();
   ~string();
   int length();
   void stringCpy(char *dest);       // copies string contents to dest
   string &operator=(string &s);
   string &operator=(char *s);
   string &operator+( string &s);
   string &operator+( char *s);
   void set(char *);
private:
   MemHandle _str;	// pointer to the actual string
   UInt32 _len;		// length of the string
};
