/*
 * Memswapdb.java
 *
 * Created on September 17, 2002, 8:15 PM
 */
package benchmarks;

import javax.microedition.rms.*;
import javax.microedition.lcdui.*;

/**
 *
 * @author  root
 */
public class Memswapdb extends benchmark {
    
    private int seedval;
    private long ARRAYSIZE = 2048;
    /** Creates a new instance of Memswapdb */
    public Memswapdb() {
        seedval = 5011971;
    }
    
    private void showAlert(){
        Display disp;
        Form form;
        disp = benchesMIDlet.getDisplay();
        form = (Form) disp.getCurrent();
        Alert a = new Alert("Exception opening memswapDB");
        a.setTimeout(Alert.FOREVER);
        disp.setCurrent(a,form);
 
    }
    public void doBenchmark() {      
        int index, temp;
        int rec1, rec2;
        byte[] buffer = new byte[10];
        RecordStore msDB=null;
        //        open a database for sorting
        try {
            msDB = RecordStore.openRecordStore("memswapDB",true); // true flag means create if necessary
        
        //  initialize ARRAYSIZE records
            for ( index=0; index < ARRAYSIZE; index++) {
                buffer=Integer.toString(index%9000+1000).getBytes();
                temp=msDB.addRecord(buffer, 0,4);
            }
            //  swap ARRAYSIZE records randomly
            for ( index=0; index < ARRAYSIZE; index++ ) {
                rec1 = rand()+1;
                rec2 = rand()+1;
                if ( rec1 != rec2 ) {
                    buffer = msDB.getRecord(rec1);
                    msDB.setRecord(rec1,msDB.getRecord(rec2),0,4);
                    msDB.setRecord(rec2,buffer,0, 4);
                }
            }
            // get rid of database
            msDB.closeRecordStore();
            msDB.deleteRecordStore("memswapDB");
        } catch (RecordStoreException rse) { showAlert(); }
    }
    
    private void srand(int seed) {
        seedval=seed;
    }
    
    private int rand() {
             int returnval;
             seedval = seedval * 1103515245 + 12345;
             returnval=(int)((seedval/65536) % ARRAYSIZE);
             if ( returnval < 0 ) { returnval = returnval * -1; }
             return returnval;
    }
    
}
