/*
 * sieve.java
 *
 * Created on September 15, 2002, 10:56 PM
 */
package benchmarks;
import javax.microedition.lcdui.*;

/**
 *
 * @author  root
 */
public class Sieve extends benchmark {
    
    private short[] pflag;
    
    /** Creates a new instance of sieve */
    public Sieve() {
        pflag=new short[16384];
    }
    
    public void doBenchmark() {
        int p;
        int iter;
        int index;
        for ( index=0 ; index < 10; index++ ) {
            for ( p = 0; p < 16384; p++ ) {   // initialize our array
               pflag[p]=1;
            }
            p=2;
            while ( p*p < 16384 ) {
                iter=2*p;
                while ( iter < 16384 ) {
                    pflag[iter] = 0;
                    iter = iter + p;
                }
                do {
                    p++;
                } while ( pflag[p] == 0 );
            }
        }
    }
    
}
