/*
 * benchmark.java
 *
 * Created on September 12, 2002, 8:11 PM
 */

package benchmarks;
import javax.microedition.lcdui.*;
import javax.microedition.rms.*;


/**
 *
 * @author  root
 */
public abstract class benchmark {
    
    protected long _startTime;
    
    protected long _endTime;
    
    protected String _Duration;
    
    protected Form _myForm;
    
    
    public abstract void doBenchmark();
    
    public final void setForm(Form theForm){
        _myForm=theForm;
    }
    
    public final String getDuration() {
        return _Duration;
    }
    public final void runBenchmark() {
        setStartTime();
        doBenchmark();
        setEndTime();
        calcElapsedTime();
    }
    
    private void setStartTime() {
        _startTime = System.currentTimeMillis();
    }
    private void setEndTime(){
        _endTime = System.currentTimeMillis();
    }
    private void calcElapsedTime(){
        String $Days="";
        String $Hours="";
        String $Minutes="";
        String $Seconds="";
        String $temp;
        
        long elapsed, frasec, sec, minutes, hours, days;
        
        elapsed =  _endTime - _startTime ;
        frasec  = elapsed % 1000;             // fraction seconds
        elapsed = elapsed / 1000;             // get rid of fra seconds
        sec     = elapsed % 60;               // seconds
        elapsed = elapsed / 60;               // get rid of seconds
        minutes = elapsed % 60;               // minutes
        elapsed = elapsed / 60;               // get rid of minutes
        hours   = elapsed % 24;               // calculate hours
        elapsed = elapsed / 24;               // get rid of hours
        days    = elapsed;                    // days
        if ( days > 0 ) { $Days    = days + " Days, "; }
        if ( hours > 0 ) { $Hours   = hours + " Hrs, "; }
        if ( minutes > 0 ) { $Minutes = minutes + "Mins, "; }
        if ( frasec > 0 ) {
            $Seconds = $Seconds + sec + ".";
            if ( frasec < 1000 ) { $Seconds = $Seconds + "0"; }  // zero fill
            if ( frasec < 100 ) { $Seconds = $Seconds + "0"; }
            if ( frasec < 10 ) { $Seconds = $Seconds + "0"; }
            $Seconds = $Seconds + frasec + " Sec."; }
        else { $Seconds = sec + "Sec."; }
        this._Duration = "";
        this._Duration = $Days + $Hours + $Minutes + $Seconds;
    }
}
