#include <PalmOS.h>
#include <PalmTypes.h>
#include "gui.h"
#include "benchmark.h"
#include "string.h"


void benchmark::setForm(form *theForm){
    _myForm=theForm;
}

char *benchmark::getDuration() {
    return _Duration;
}
void benchmark::runBenchmark() {
    setStartTime();
    doBenchmark();
    setEndTime();
    calcElapsedTime();
}
    
void benchmark::setStartTime() {
    UInt32 ticspersecond;
    UInt32 milliseconds;
    ticspersecond= ( UInt32 ) SysTicksPerSecond();
    milliseconds= ( UInt32 ) TimGetTicks();
    milliseconds=milliseconds*1000/ticspersecond;
    _startTime = milliseconds;
}
    void benchmark::setEndTime(){
    UInt32 ticspersecond;
    UInt32 milliseconds;
    ticspersecond = ( UInt32 ) SysTicksPerSecond();
    milliseconds = ( UInt32 ) TimGetTicks();
    milliseconds=milliseconds*1000/ticspersecond;
    _endTime = milliseconds;
}
void benchmark::calcElapsedTime(){
    string Days;
    string Hours;
    string Minutes;
    string Seconds;
    char temp[40];
    
    UInt32 elapsed, frasec, sec, minutes, hours, days;
        
    elapsed = _endTime - _startTime ;
    frasec  = elapsed % 1000;             // fraction seconds
    elapsed = elapsed / 1000;             // get rid of fra seconds
    sec     = elapsed % 60;               // seconds
    elapsed = elapsed / 60;               // get rid of seconds
    minutes = elapsed % 60;               // minutes
    elapsed = elapsed / 60;               // get rid of minutes
    hours   = elapsed % 24;               // calculate hours
    elapsed = elapsed / 24;               // get rid of hours
    days    = elapsed;                    // days
    _Duration[0]=0;

    if ( days > 0 ) { 
        StrIToA( temp, days );
        Days    = Days + " Days, " + temp;
    }
    if ( hours > 0 ) { 
        StrIToA( temp, hours );
        Hours   = Hours + " Hrs, " + temp;
    }
    if ( minutes > 0 ) {
        StrIToA( temp, minutes );
        Minutes = Minutes + "Mins, " + temp;
    }
    
    if ( frasec > 0 ) {
        StrIToA( temp, sec );
        Seconds = Seconds + temp + "." ;
        if ( frasec < 1000 ) { Seconds = Seconds + "0"; }
        if ( frasec < 100 ) { Seconds = Seconds + "0"; }
        if ( frasec < 10 ) { Seconds = Seconds + "0"; }
        StrIToA( temp, frasec );
        Seconds = Seconds + temp + " Sec.";
    }
    else {
        StrIToA( temp, sec );
        Seconds = Seconds + temp + " Sec.";
    }
    Days = Days + Hours + Minutes + Seconds;
    Days.stringCpy( _Duration );
}
