#include <PalmOS.h>
#include <PalmTypes.h>
#include "gui.h"
#include "benchmark.h"
#include "memswap.h"

// memory swapping algorithm
memswap::memswap(){
    UInt16 index;
    for ( index=0; index < 16384; index++ ) {
        swaparea[index]=index;
    }
}
  
void memswap::doBenchmark() {
    int swapsize, seg1, seg2, index;
    short temp;
    for ( index = 1; index <= 10; index ++ ) {
       swapsize=1;
       seg2 = 8191;
       while ( swapsize < 8192 ) {
           seg1 = 8192 - swapsize;
           seg2 = 8191 + swapsize;
   
           temp = swaparea[seg1];
           swaparea[seg2] = swaparea[seg1];
           swaparea[seg1] = temp;
   
           swapsize++;
       }
    }
}
