#include <PalmOS.h>
#include <PalmTypes.h>
#include "gui.h"
#include "benchmark.h"
#include "sieve.h"

// sieve of Erotosthenes
void sieve::doBenchmark() {
   int p;
   int iter;
   int index;
   for ( index=0 ; index < 10; index++ ) {
      for ( p = 0; p < 16384; p++ ) {   // initialize our array
         pflag[p]=1;
      }
      p=2;
      while ( p*p < 16384 ) {
         iter=2*p;
         while ( iter < 16384 ) {
            pflag[iter] = 0;
            iter = iter + p;
         }
         do {
            p++;
         } while ( pflag[p] == 0 );
      }
   }
}
